# Changelog

All notable changes to this project will be documented in this file.

## [0.4.3] - 2024-02-22

### Features

- Internal `from_raw` methods for db totalizers
- Thorough merge strategy for `NodeById`
- Make opb defaults more like pbo competition specs
- Output opbs with `#variable` line

### Bug Fixes

- Remove `weight_sum` field from `DbGte`

### Documentation

- Disable cbindgen on docs.rs

<!-- generated by git-cliff -->
<!-- generated by git-cliff -->
## [0.4.2] - 2024-01-11

### Documentation

- Mark required features in documentation on [docs.rs](https://docs.rs/rustsat)

## [0.4.1] - 2024-01-11

### Documentation

- Improve doc examples
- Add shields to READMEs

### Features

- Helpful shortcuts in instances and solver
- Index assignments by var and negate ternary vals

<!-- generated by git-cliff -->
## [0.4.0] - 2023-12-18

### Bug Fixes

- Set var manager in SatInstance::from_iter
- Set vm correctly in SatInstance::from(Cnf)
- Coarse convergence bounds
- Link capi tests to archive libs
- Typo in capi
- Parse empty instances correctly
- Limited connections in node db
- Next value in db-referencing gtes

### Documentation

- (limited) python api documentation

### Features

- Python api expose lit, clause, cnf
- Python len and indexing support for clause and cnf
- Feature switch for python api
- Python iterators
- Totalizer and comparison operators in pyapi
- Expose all encodings in python api
- Extend internal node api
- Limited connections in node db
- Constant method for objective
- Allow cloning totalizer db

## [0.3.0]

### Refactor

- Allow encodings to output straight to solvers

### Features

- Alternative totalizer implementation based on a totalizer database
- Dynamic polynomial watchdog encoing
- Changes to public API: changed some vectores to slices
- Changed internal variable/literal representation from `usize` to `u32`

## [0.2.x]

Solver interfaces factored out into seperate crates.
See detailed changes in [GitHub Releases](https://github.com/chrjabs/rustsat/releases).

## [0.1.2]

Updated initial version with working dependencies.

## [0.1.0] and [0.1.1]

Yanked because of dependencies that don't exist anymore
